public class VarArgs{

	public static void main(String ... args){
		System.out.println(add(1, 2));
		System.out.println(add(1, 2, 3));

		System.out.println(add(new int[]{1, 2}));
		System.out.println(add(new int[]{1, 2, 3}));
	}

	// Methode mit variabler Anzahl an Argumenten
	// Der Uebergabe-Parameter innerhab der Methode
	// ist in diesem Fall immer ein Array des ent-
	// sprechenden Datentyps!
	// -> Daher kann auch ein Array uebergeben werden!
	public static int add(int ... array){
		int sum=0;
		for(int x: array){
			sum += x;
		}
		return sum;
	}
}

// So muesste das ohne var-args aussehen:

/*
public class VarArgs{

	public static void main(String ... args){
		System.out.println(add(1, 2));			// Aufruf 1
		System.out.println(add(1, 2, 3));		// Aufruf 2

		System.out.println(add(new int[]{1, 2}));	// Aufruf 3
		System.out.println(add(new int[]{1, 2, 3}));	// Aufruf 4


	}

	// Methode mit 2 Parametern (Aufruf 1)
	public static int add(int a, int b){
		return a+b;
	}

	// Methode mit 3 Parametern (Aufruf 2)
	public static int add(int a, int b, int c){
		return a+b+c;
	}

	// Methode mit Array (Aufruf 3&4)
	public static int add(int[] array){
		int sum=0;
		for(int x: array){
			sum += x;
		}
		return sum;
	}
}
*/
