import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;

// View
public class PointSetPanel extends JPanel implements ChangeListener {
    private PointSet s;
    private Color bg = Color.white;
    private Color fg = Color.black;	

    public PointSetPanel(PointSet s, Color bg) {
        this.s = s;
	this.bg=bg;
	this.fg=(bg==Color.black)?Color.white:Color.black;
	// View registriert sich beim Modell
	s.addChangeListener(this);
	setPreferredSize(new Dimension(200, 100));
	setBackground(bg);
	setForeground(fg);
    }
    // View wird vom Modell benachrichtigt und aktualisiert sich
    public void pointAdded() {
        repaint();
    }
    public void paintComponent(Graphics g) {
	int width = getWidth();
	int height = getHeight();

	g.setColor(bg);
	g.fillRect(0, 0, width, height);
	
	g.setColor(fg);
	for (Iterator i = s.iterator(); i.hasNext();) {
	    Point p = (Point) i.next();
	    int x = (int) p.getX();
	    int y = (int) p.getY();
	    g.fillRect(x-1, y-1, 2, 2);
	}
    }
}
